<?php
$service_details = $this->service->get_service_id($this->uri->segment('2'));
$service_id = $service_details['id'];
$user_currency_code = '';
$userId = $this->session->userdata('id');
$tax_settings = settingValue('tax_module');
$tax_count = count($taxes);

If (!empty($userId)) {
    $service_amount = $service_details['service_amount'];
    $get_currency = get_currency();
    $user_currency = get_user_currency();
    $user_currency_code = $user_currency['user_currency_code'];

    $service_amount = get_gigs_currency($service_details['service_amount'], $service_details['currency_code'], $user_currency_code);
} else {
    $user_currency_code = settings('currency');
    $service_amount = $service_details['service_amount'];
}    
if (is_nan($service_amount) || is_infinite($service_amount)) {
    $service_amount = $service_details['service_amount'];
}

?>
<div class="content">
    <div class="container">
        <div class="row justify-content-center">
            <div class="col-lg-10">

                <div class="section-header text-center">
                    <h2><?php echo (!empty($user_language[$user_selected]['lg_Book_Service'])) ? $user_language[$user_selected]['lg_Book_Service'] : $default_language['en']['lg_Book_Service']; ?></h2>
                </div>


                <form method="post" enctype="multipart/form-data" autocomplete="off" id="book_services" >
                    <input type="hidden" name="<?php echo $this->security->get_csrf_token_name(); ?>" value="<?php echo $this->security->get_csrf_hash(); ?>" />
                    <input type="hidden" name="currency_code" value="<?php echo $user_currency_code; ?>">
                    <div class="row">
                        <div class="col-lg-6">
						    <div class="form-group">
                                <label><?php echo (!empty($user_language[$user_selected]['lg_Service_Location'])) ? $user_language[$user_selected]['lg_Service_Location'] : $default_language['en']['lg_Service_Location']; ?> <span class="text-danger">*</span></label>
                                <input class="form-control" type="text" name="service_location" <?php if(settingValue('location_type') == 'live') { ?> id="service_location" <?php } else { ?> id="service_locations" <?php } ?>required>
                                <input type="hidden" class="form-control" id="map_key" value="<?php echo settingValue('map_key'); ?>" >
                                <input type="hidden" class="form-control" id="service_location_types" value="<?php echo settingValue('location_type'); ?>" >
                                <input type="hidden" name="service_latitude" id="service_latitude">
                                <input type="hidden" name="service_longitude" id="service_longitude">
                            </div>                            
                        </div>

                        <div class="col-lg-6">
                            <div class="form-group">
                                <label><?php echo (!empty($user_language[$user_selected]['lg_Service_Amount'])) ? $user_language[$user_selected]['lg_Service_Amount'] : $default_language['en']['lg_Service_Amount']; ?></label>
                                <input class="form-control" type="text" name="service_amount" id="service_amount" value="<?php echo currency_conversion($user_currency_code) . $service_amount; ?>" readonly="">
                            </div>
                        </div>

                        <div class="col-lg-6">
                           <div class="form-group">
                                <label><?php echo (!empty($user_language[$user_selected]['lg_Date'])) ? $user_language[$user_selected]['lg_Date'] : $default_language['en']['lg_Date']; ?> <span class="text-danger">*</span></label>
                                <input class="form-control" type="text" name="booking_date" id="booking_date" />

                                <input type="hidden" name="provider_id" id="provider_id" value="<?php echo $service_details['user_id'] ?>">
                                <input type="hidden" name="service_id" id="service_id" value="<?php echo $service_details['id'] ?>">
                            </div>
                        </div>

                        <div class="col-lg-6">
                            <div class="form-group">
                                <label><?php echo (!empty($user_language[$user_selected]['lg_timeslot'])) ? $user_language[$user_selected]['lg_timeslot'] : $default_language['en']['lg_timeslot']; ?> <span class="text-danger">*</span></label>
                                <select class="form-control from_time" name="from_time" id="from_time" required>
                                </select>

                            </div>
                        </div>
                        <div class="col-lg-12">
                            <div class="form-group">
                                <div class="text-center">
                                    <div id="load_div"></div>
                                </div>
                                <label><?php echo (!empty($user_language[$user_selected]['lg_notes'])) ? $user_language[$user_selected]['lg_notes'] : $default_language['en']['lg_notes']; ?></label>
                                <textarea class="form-control" name="notes" id="notes" rows="5"></textarea>
                            </div>
                        </div>
                        <?php if( settingValue('additional_services_showhide') == 1 ) {?>
                        <!-- additional service -->
                        <?php  $addi_ser = $this->db->select('id, service_id,service_name, amount,duration,duration_in')->where('status',1)->where('service_id',$service_id)->get('additional_services')->result_array();
                      
									if(count($addi_ser) > 0) {  
								?>
								<div class="col-lg-12">
									<div class="form-group">
										<label class="mb-0"><?php echo (!empty($user_language[$user_selected]['lg_Additional_Services'])) ? $user_language[$user_selected]['lg_Additional_Services'] : $default_language['en']['lg_Additional_Services']; ?></label>
									</div>
								</div>
								<div class="col-lg-7">
									<div class="add-ser-list">
										<?php 
                                        $totalAddService = 0;
                                        foreach($addi_ser as $a => $ai) { 
                                            $additionalServiceAmount = get_gigs_currency($ai['amount'], $service_details['currency_code'], $user_currency_code);

                                            $totalAddService += $additionalServiceAmount;
                                            ?>
                                            
										<div class="additional-service">
											<div class="additional-content">
												<div class="form-check">
													<input type="checkbox" class="form-check-input addiservice" name="additional_services[]" value="<?php echo $ai['id']; ?>" id="addichkbox_<?php echo $a; ?>" data-durationval="<?php echo $ai['duration']; ?>" data-amountval="<?php echo $additionalServiceAmount; ?>">
													<label class="form-check-label mb-0" for="addichkbox_<?php echo $a; ?>"><?php echo $ai['service_name']; ?>
													<p><?php echo $ai['duration']."<span class='small'>".$ai['duration_in']."</span>"; ?></span> </p></label>
												</div>
											</div>
											<div class="additional-price">
												<?php echo  currency_conversion($user_currency_code) . $additionalServiceAmount;?></span>
											</div>
										</div>
                                       
										<?php } ?>
									</div>
								</div>
								<?php }
                                } ?>
                        
                        
                        <input type="hidden" id="tax_Settings_val" value="<?php echo $tax_settings; ?>">
                        <input type="hidden" id="currencySign" value="<?php echo currency_conversion($user_currency_code); ?>">
                        <?php 
                        if($tax_settings == 1 && $tax_count > 0) {?>
                        <div class="col-lg-7">
                            <div class="form-group book-user-service-tax">
                                <label><?php echo (!empty($user_language[$user_selected]['lg_tax_included'])) ? $user_language[$user_selected]['lg_tax_included'] : $default_language['en']['lg_tax_included']; ?></label>
                                <br>
                               <?php 
                                $total = 0;   
                               foreach($taxes as $tax) { 
                                // <!-- tax calculation -->
                                          
                                $tax_amount = $service_amount *( $tax['tax_percent']/100);                   
                                $total += $tax_amount;
                                ?>
                                <div class="tr-row">
                                <input type="hidden" id="changed_tot_tax" value="<?php echo $checkTotTax; ?>">
                                <input type="hidden" class ="row_tax_id" name="row_tax_id[]" value="<?php echo $tax['id']; ?>">
                                <input type="hidden" class ="row_tax_name" name="row_tax_name[]" value="<?php echo $tax['tax_name']; ?>">
                                <input type="hidden" class ="row_tax_percentage" name="row_tax_percentage[]" value="<?php echo $tax['tax_percent']; ?>">
                                <input type="hidden" class ="row_tax_amount" name="row_tax_amount[]" value="<?php echo currency_conversion($user_currency_code) . round($tax_amount,2); ?>">
                              
                                <input type="hidden" id="change_tax_percent_<?php echo $tax['id']; ?>" value="<?php echo $tax['tax_percent']; ?>">
                               
                                <div class="book-ser-user-cgst">
                                <label class="service-users-gst"><?php echo $tax['tax_name']."(".$tax['tax_percent']."% )"; ?></label>
                                <input class="form-control tax_amount" type="text" name="tax_amount_<?php echo $tax['id']; ?>" id="tax_amount_<?php echo $tax['id']; ?>" value="<?php echo currency_conversion($user_currency_code) . round($tax_amount,2); ?>" readonly="">
                                </div>
                                </div>
                               <?php } ?>
                                
                            </div>
                        </div>
                        <?php }
                        
                        $totalServiceAmount = $total+$service_amount;
                        ?>
                        
                        <div class="col-lg-7 mb-3">
                            <div class="form-group book-ser-user-cgst">
                            <input type="hidden" id="service_with_additional" value="<?php echo $service_with_additional; ?>">

                                <label><?php echo (!empty($user_language[$user_selected]['lg_total_amount'])) ? $user_language[$user_selected]['lg_total_amount'] : $default_language['en']['lg_total_amount']; ?></label>
                                <input class="form-control tot-amount-user" type="text" name="service_amounts" id="service_amounts" value="<?php echo currency_conversion($user_currency_code) . round($totalServiceAmount,2); ?>" readonly="">
                            </div>
                        </div>
						<div class="col-lg-12">
							<div class="form-group">
								<label>Payment Method</label>
								<div>
                                <?php if (settingValue('wallet_option') == 1) { ?>		
									<label class="radio-inline"><input class="cod"  type="radio" name="cod" value="2" checked> <?php echo (!empty($user_language[$user_selected]['lg_wallet'])) ? $user_language[$user_selected]['lg_wallet'] : $default_language['en']['lg_wallet']; ?> </label>
                                <?php } ?>
									<?php 
                                    $get_cod_option_status = $this->db->where('key','cod_option')->get('system_settings')->row()->value;
                                    $cod_option_status =($get_cod_option_status)?$get_cod_option_status:0;
                                    if(!empty($cod_option_status)) { ?>
                                    <label class="radio-inline"><input class="cod"  type="radio" name="cod" value="1"> <?php echo (!empty($user_language[$user_selected]['lg_cash_on_delivery'])) ? $user_language[$user_selected]['lg_cash_on_delivery'] : $default_language['en']['lg_cash_on_delivery']; ?> </label>
                                    <?php } ?>
								</div>
							</div>
						</div>


                    </div>

                    <div class="submit-section">
                        <button class="btn btn-primary submit-btn submit_service_book" data-loading-text="<i class='fa fa-spinner fa-spin '></i> Processing Order" data-id="<?php echo $service_details['id']; ?>" data-provider="<?php echo $service_details['user_id'] ?>" data-amount="<?php echo $service_details['service_amount']; ?>" type="submit" id="submit"><?php echo (!empty($user_language[$user_selected]['lg_continue_to_book'])) ? $user_language[$user_selected]['lg_continue_to_book'] : $default_language['en']['lg_continue_to_book']; ?></button>
                    </div>
                </form>
            </div>
        </div>
    </div>
</div>
