<?php

defined('BASEPATH') OR exit('No direct script access allowed');

class Language_new extends CI_Controller {

    public $data;

    public function __construct() {
       
        parent::__construct();
        $this->load->helper('form');
        $this->load->model('language_model');
        $this->load->model('common_model');
        $this->load->model('language_web_model', 'web_language');
        $this->load->model('admin_model', 'admin');
        $this->data['theme'] = 'admin';
        $this->data['model'] = 'language';
        $this->data['base_url'] = base_url();
        $this->load->helper('custom_language');
        $langs = !empty($this->session->userdata('lang'))?$this->session->userdata('lang'):'en';
        $lang = $this->db->get_where('language', array('language_value'=>$langs))->row()->language;
        $this->data['language_content'] = $this->lang->load('content', strtolower($lang), true);
        $this->language = $this->lang->load('content', strtolower($lang), true);

        $this->session->keep_flashdata('error_message');
        $this->session->keep_flashdata('success_message');
        $this->load->helper('user_timezone_helper');
        $this->data['user_role'] = $this->session->userdata('role');
    }

    public function index() 
    {
        $this->data['page'] = 'languages_new';
        $this->data['list'] = $this->admin->language_list();
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function AddLanguages() {
        $this->data['page'] = 'add_languages';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function InsertLanguage() {
        $this->common_model->checkAdminLogin();
        $postdata = $this->input->post();

        $data = [
            'language' => $postdata['language_name'],
            'language_value' => $postdata['language_value'],
            'tag' => $postdata['language_type'],
        ];
        $insert = $this->db->insert('language', $data);
        if (!empty($insert) && $insert != '') {
            $message = (!empty($this->data['language_content']['lg_admin_language_add'])) ? $this->data['language_content']['lg_admin_language_add'] : 'Language added successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "language");
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_language_not_add'])) ? $this->data['language_content']['lg_admin_language_not_add'] : 'Language added not successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-language");
        }
    }

    public function Wep_Language() {
        $this->data['page'] = 'wep_language';
        $this->data['active_language'] = $this->language_model->active_language();
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function AddWepKeyword($lang_key) {
        if($this->input->post('form_submit') == true) {
            $this->common_model->checkAdminLogin();
            $postdata = $this->input->post();
            $data = [
                'lang_value' => $postdata['filed_name'],
                'lang_key' => str_replace(array(' ', '!', '&'), '_', 'lg_'.strtolower($postdata['key_name'])),
                'language' => $lang_key,
                'type' => 'web'
            ];
            $insert = $this->db->insert('language_management', $data);
            if (!empty($insert) && $insert != '') {
                language_file_create(); // language folder create
                $message = (!empty($this->data['language_content']['lg_admin_language_keyword_add'])) ? $this->data['language_content']['lg_admin_language_keyword_add'] : 'Language keyword added successfully. ';
                $this->session->set_flashdata('success_message', $message);
                redirect(base_url() . "web-languages/".$lang_key);
            } else {
                $message = (!empty($this->data['language_content']['lg_admin_language_key_not_add'])) ? $this->data['language_content']['lg_admin_language_key_not_add'] : 'Language keyword added not successfully. ';
                $this->session->set_flashdata('error_message', $message);
                redirect(base_url() . "add-wep-keyword".$lang_key);
            }
        }
        $this->data['page'] = 'add_wep_keyword';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }
    // Language Module

    public function LanguageModuleList() 
    {
       
        $this->data['list'] = $this->language_model->languageModule_list();
       
        $this->data['page'] = 'language_module_list';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function AddLanguageModule() {
        $this->data['page'] = 'add_language_module';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }


    public function insertLanguageModule() {
    
        $this->common_model->checkAdminLogin();
        $postdata = $this->input->post();
        
        $check = $this->checkLanguageModuleName();
        if(!$check){
            $message = (!empty($this->data['language_content']['lg_admin_module_name_exist'])) ? $this->data['language_content']['lg_admin_module_name_exist'] : 'Module Name already exist. ';
            $this->session->set_flashdata('error_message',  $message);
            redirect(base_url() . "add-language-module");
        }
        $moduleInsert = [
            'module_name' => $postdata['module_name'],
        ];

        $insertModule = $this->db->insert('language_module', $moduleInsert);
        if (!empty($insertModule) && $insertModule != '') {
            $message = (!empty($this->data['language_content']['lg_admin_module_name_add'])) ? $this->data['language_content']['lg_admin_module_name_add'] : 'Module Name added successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "language-module/".$lang_key);
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_module_name_not_add'])) ? $this->data['language_content']['lg_admin_module_name_not_add'] : 'Module Name not added  successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-language-module");
        }
    }

    public function editLanguageModule($id){
       
        if (!empty($id)) {
           
            if ($this->input->post('form_submit')) {
               
                $id = $this->input->post('id');

                $table_data['module_name'] = $this->input->post('module_name');
                $check = $this->checkLanguageModuleName();
                if(!$check){
                    $message = (!empty($this->data['language_content']['lg_admin_module_name_exist'])) ? $this->data['language_content']['lg_admin_module_name_exist'] : 'Module Name already exist. ';
                    $this->session->set_flashdata('error_message', $message);
                    redirect(base_url() . "edit-language-module/".$id);
                }
                $this->db->where('id', $id);
                if ($this->db->update('language_module', $table_data)) {
                    $message = (!empty($this->data['language_content']['lg_admin_language_module_update'])) ? $this->data['language_content']['lg_admin_language_module_update'] : 'Langugae Module updated successfully. ';
                    $this->session->set_flashdata('success_message', $message);
                    redirect(base_url() . "language-module");
                } else {
                    $message = (!empty($this->data['language_content']['lg_something_went_wrong'])) ? $this->data['language_content']['lg_something_went_wrong'] : 'Something went wrong, Try again';
                    $this->session->set_flashdata('error_message', $message);
                    redirect(base_url() . "edit-language-module/".$id);
                }
            }
            
            $this->data['page'] = 'edit_language_module';
            $this->data['pages'] = $this->language_model->edit_languageModule($id);
            $this->load->vars($this->data);
            $this->load->view($this->data['theme'] . '/template');
        }
    }

    public function checkLanguageModuleName() {
       
        $module_name =strip_tags($this->input->post('module_name'));
        $id = $this->input->post('id');
       
        if (!empty($id)) {
            $this->db->select('*');
            $this->db->where('replace(module_name," ","")=replace("' . $module_name . '"," ","")');
            $this->db->where('id !=', $id);
            $this->db->where('status', 1);
            $this->db->from('language_module');
            $result = $this->db->get()->num_rows();
        } else {
           
            $this->db->select('*');
			$this->db->where('status', 1);
            $this->db->where('replace(module_name," ","")=replace("' . $module_name . '"," ","")');
            $this->db->from('language_module');
            $result = $this->db->get()->num_rows();
            
        }

        if ($result > 0) {
            $isAvailable = FALSE;
        } else {
            $isAvailable = TRUE;
        }
        return $isAvailable;
    }

    public function checkLanguageKeywordName() {
       
        $lang_key =strip_tags($this->input->post('lang_key'));
        
        $id = $this->input->post('id');
       
        if (!empty($id)) {
            $this->db->select('*');
            $this->db->where('replace(lang_key," ","")=replace("' . $lang_key . '"," ","")');

            $this->db->where('id !=', $id);
            $this->db->where('status', 1);
            $this->db->from('language_keywords_management');
            $result = $this->db->get()->num_rows();
        } else {
           
            $this->db->select('*');
			$this->db->where('status', 1);
            $this->db->where('replace(lang_key," ","")=replace("' . $lang_key . '"," ","")');
            $this->db->from('language_keywords_management');
            $result = $this->db->get()->num_rows();
            
        }

        if ($result > 0) {
            $isAvailable = FALSE;
        } else {
            $isAvailable = TRUE;
        }
        return $isAvailable;
    }

    public function languageKeywordList($module_id) 
    {
        $this->data['list'] = $this->language_model->languageKeyword_list($module_id);
        $this->data['page'] = 'language_keyword_list';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function AddLanguageKeyword() {
        $this->data['page'] = 'add_language_keyword';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }


    public function InsertLanguageKeyword() {
        $this->common_model->checkAdminLogin();
        $postdata = $this->input->post();
        
        $check = $this->checkLanguageKeywordName();
        
        $module_id = $postdata['module_id'];
        $lang_key = $postdata['lang_key'];
        $lang_value = $postdata['lang_value'];
        $type = $postdata['type'];
        if(!$check){
            $message = (!empty($this->data['language_content']['lg_admin_language_keyword_exist'])) ? $this->data['language_content']['lg_admin_language_keyword_exist'] : 'Language Keyword already exist. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-language-keyword/".$module_id);
        }
        $PageInsert = [
            'module_id' => $module_id,
            'lang_key' => $lang_key,
            'lang_value' => $lang_value,
            'type' => $type
        ];
        $insertPage = $this->db->insert('language_keywords_management', $PageInsert);
        if (!empty($insertPage) && $insertPage != '') {
            $message = (!empty($this->data['language_content']['lg_admin_language_keyword_add'])) ? $this->data['language_content']['lg_admin_language_keyword_add'] : 'Langugae Keyword added successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "language-keyword-list/".$module_id);
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_language_key_not_add'])) ? $this->data['language_content']['lg_admin_language_key_not_add'] : 'Langugae Keyword  not added successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-language-keyword/".$module_id);
        }
    }

    public function editLanguageKeyword($id) {
      
        $this->data['keyword'] = $this->language_model->get_language_keyword_id($id);
        $this->data['page'] = 'edit_language_keyword';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function updateLanguageKeyword() {
        
      
        $id = $this->input->post('id');
        $this->db->where('id', $id);
        $data = $this->db->get('language_keywords_management')->row_array();
        
        if (!empty($data)) {
           
            $table_data['lang_key'] = $this->input->post('lang_key');
            $table_data['lang_value'] = $this->input->post('lang_value');
          
            $this->db->where('id', $id);
            $this->db->update('language_keywords_management', $table_data);
            $message = (!empty($this->data['language_content']['lg_admin_keyword_update'])) ? $this->data['language_content']['lg_admin_keyword_update'] : 'Keywords updated successfully. ';
            $this->session->set_flashdata('success_message', $message);
            
            redirect(base_url() . "language-keyword-list/".$data['module_id']);
            
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_keyword_not_update'])) ? $this->data['language_content']['lg_admin_keyword_not_update'] : 'Keywords not updated successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "edit-keyword-list/".$data['id']);
        }
    }



    public function AppPageList($lang) 
    {

        $this->data['list'] = $this->language_model->page_list();
        $this->data['page'] = 'app_page_list';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function AddAPPKeyword() {
        $this->data['page'] = 'add_app_keyword';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function pages_language() {
        $lang = $this->uri->segment(3);
        $this->data['page'] = 'pages_language';
        $this->data['active_language'] = $this->db->get_where('language', array('status'=>1, 'language_value'=>$lang))->result_array();
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }
    
    public function AllAPPKeyword() {
        $this->data['page'] = 'all_app_keyword';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function InsertWepKeyword() {
        $postdata = $this->input->post();

        $data = [
            'lang_value' => $postdata['filed_name'],
            'lang_key' => trim($postdata['key_name']),
            'language' => 'en'
        ];
        $insert = $this->db->insert('language_management', $data);
        if (!empty($insert) && $insert != '') {
            $message = (!empty($this->data['language_content']['lg_admin_language_add'])) ? $this->data['language_content']['lg_admin_language_add'] : 'Language added successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "wep_language");
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_language_not_add'])) ? $this->data['language_content']['lg_admin_language_not_add'] : 'Language added not successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-wep-keyword");
        }
    }

    public function InsertAppKeyword() {
        $this->common_model->checkAdminLogin();
        $postdata = $this->input->post();
        $page_name = $postdata['page_name'];
        $lang_key = $postdata['lang_key'];
        $page_key = str_replace(array(' ', '!', '&'), '_', strtolower($page_name));
        $PageInsert = [
            'page_title' => $postdata['page_name'],
            'page_key' => $page_key,
            'status' => 1
        ];
        $insertPage = $this->db->insert('pages', $PageInsert);
        if (!empty($insertPage) && $insertPage != '') {
            $message = (!empty($this->data['language_content']['lg_admin_add_page'])) ? $this->data['language_content']['lg_admin_add_page'] : 'Page added successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "app-page-list/".$lang_key);
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_not_add_page'])) ? $this->data['language_content']['lg_admin_not_add_page'] : 'Page added not successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-app-keyword");
        }
    }

    public function language_web_list() {
        $lists = $this->web_language->language_list();
        $data = array();
        $no = $_POST['start'];
        $active_language = $this->web_language->active_language();
        foreach ($lists as $keyword) {
            $row = array();
            if (!empty($active_language)) {
                foreach ($active_language as $rows) {
                    $lg_language_name = $keyword['lang_key'];
                    $language_key = $rows['language_value'];
                    $key = $keyword['language'];
                    $value = ($language_key == $key) ? $keyword['lang_value'] : '';
                    $key = $keyword['language'];
                    $currenct_page_key_value = $this->web_language->currenct_page_key_value($lists);
                    $name = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['name'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['name'] : '';
                    $lang_key = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['lang_key'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['lang_key'] : '';
                    $readonly = '';

                    $row[] = '<input type="text" class="form-control" placeholder="Name" name="' . $lg_language_name . '[' . $language_key . '][lang_value]" value="' . $name . '" ' . $readonly . ' ><br>
                            <input type="text" class="form-control" value="' . $lang_key . '" readonly >
                         ';
                }
            }

            $data[] = $row;
        }

        $output = array(
            "draw" => $_POST['draw'],
            "recordsTotal" => $this->web_language->language_list_all(),
            "recordsFiltered" => $this->web_language->language_list_filtered(),
            "data" => $data,
        );
        echo json_encode($output);
    }

    public function update_multi_web_language() {

        if ($this->input->post()) {
            if ($this->data['admin_id'] > 1) {
                $message = (!empty($this->data['language_content']['lg_no_permission'])) ? $this->data['language_content']['lg_no_permission'] : 'Permission Denied';
                $this->session->set_flashdata('error_message', '<p class="alert alert-danger">'.$message.'</p>');
                // $this->session->set_flashdata('error_message', '<p class="alert alert-danger">Permission Denied</p>');
                redirect(base_url() . 'wep_language');
            } else {
                $data = $this->input->post();

                foreach ($data as $row => $object) {
                    if (!empty($object)) {
                        foreach ($object as $key => $value) {
                            $this->db->where('language', $key);
                            $this->db->where('lang_key', $row);
                            $record = $this->db->count_all_results('language_management');
                            if ($record == 0) {
                                $array = array(
                                    'language' => $key,
                                    'lang_key' => $row,
                                    'lang_value' => $value['lang_value'],
                                );

                                $this->db->insert('language_management', $array);
                            } else {

                                $this->db->where('language', $key);
                                $this->db->where('lang_key', $row);


                                $array = array(
                                    'lang_value' => $value['lang_value'],
                                );

                                $this->db->update('language_management', $array);
                            }
                        }
                    }
                }
            }
        }
        redirect(base_url() . 'wep_language');
    }

    public function language_list() {
        $page_key = $this->input->post('page_key');
        $lang_key = $this->input->post('lang_key');
        
        $lists = $this->language_model->language_list($page_key, $lang_key);
        $data = array(); 
        $no = $_POST['start'];
        $active_language = $this->language_model->active_language();

        foreach ($lists as $keyword) {
            $row = array();
            if (!empty($active_language)) {
                foreach ($active_language as $rows) {

                    $lg_language_name = $keyword['lang_key'];
                    $language_key = $rows['language_value'];


                    $key = $keyword['language'];
                    $value = ($language_key == $key) ? $keyword['lang_value'] : '';
                    $key = $keyword['language'];
                    $currenct_page_key_value = $this->language_model->currenct_page_key_value($lists);



                    $name = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['name'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['name'] : '';
                    $placeholder = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['placeholder'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['placeholder'] : '';
                    $validation1 = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['validation1'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['validation1'] : '';
                    $validation2 = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['validation2'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['validation2'] : '';
                    $validation3 = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['validation3'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['validation3'] : '';
                    $lang_key = (!empty($currenct_page_key_value[$lg_language_name][$language_key]['lang_key'])) ? $currenct_page_key_value[$lg_language_name][$language_key]['lang_key'] : '';


                    $type = $currenct_page_key_value[$lg_language_name]['en']['type'];
                    $langVal = str_replace('_', ' ', $lang_key); 
                    $langValues = ltrim($langVal, 'lbl_'); 
                    $langKeywords = ucfirst($langValues);

                    $readonly = '';


                    $row[] = '<input type="text" class="form-control" placeholder="Name" name="' . $lg_language_name . '[' . $language_key . '][lang_value]" value="' . $name . '" ' . $readonly . ' ><br>
                          <input type="text" class="form-control" placeholder="Placeholder" name="' . $lg_language_name . '[' . $language_key . '][placeholder]" value="' . $placeholder . '" ' . $readonly . ' ><br>
                          <input type="text" class="form-control" placeholder="Validation 1" name="' . $lg_language_name . '[' . $language_key . '][validation1]" value="' . $validation1 . '" ' . $readonly . ' ><br>
                          <input type="text" class="form-control" placeholder="Validation 2" name="' . $lg_language_name . '[' . $language_key . '][validation2]" value="' . $validation2 . '" ' . $readonly . ' ><br>
                          <input type="text" class="form-control" placeholder="Validation 3" name="' . $lg_language_name . '[' . $language_key . '][validation3]" value="' . $validation3 . '" ' . $readonly . ' ><br>
                          <input type="text" class="form-control" value="' . $langKeywords . '" readonly >
                          <input type="hidden" class="form-control" name="' . $lg_language_name . '[' . $language_key . '][type]" value="' . $type . '" ' . $readonly . ' >';
                }
            }

            $data[] = $row;
        }
        $output = array(
            "draw" => $_POST['draw'],
            "recordsTotal" => $this->language_model->language_list_all($page_key),
            "recordsFiltered" => $this->language_model->language_list_filtered($page_key),
            "data" => $data,
        );

        //output to json format
        echo json_encode($output);
    }

    public function update_language_status() {

        $id = $this->input->post('id');
        $status = $this->input->post('update_language');

        if ($status == 2) {
            $this->db->where('id', $id);
            $this->db->where('default_language', 1);
            $data = $this->db->get('language')->result_array();

            if (!empty($data)) {
                echo "0";
            } else {
                $this->db->query(" UPDATE `language` SET `status` = " . $status . " WHERE `id` = " . $id . " ");
                echo "1";
            }
        } else {
            $this->db->query(" UPDATE `language` SET `status` = " . $status . " WHERE `id` = " . $id . " ");
            echo "1";
        }
    }
    public function delete_language() {
        $this->common_model->checkAdminLogin();
        $id = $this->input->post('id');
		$this->db->where('language',$id)->delete('language_management');
		$this->db->where('language',$id)->delete('app_language_management');
		$result = $this->db->where('language_value',$id)->delete('language');
		  if($result){
			echo "success";
		  }else{
			echo "error";
		  }
    }
    public function update_language_default() {
        $id = $this->input->post('id');
        $this->db->where('id', $id);
        $data = $this->db->get('language')->row_array();
        if (!empty($data)) {
            $this->session->set_userdata('lang',$data['language_value']);
            $this->db->query("UPDATE language SET default_language = ''");
            $this->db->query(" UPDATE `language` SET `default_language` = 1, `status` = 1 WHERE `id` = " . $id . " ");
            $this->db->query(" UPDATE `system_settings` SET `value` = '" .$data['language_value']. "' WHERE `key` = 'language' ");
            echo "1";
        } else {
            echo "0";
        }
    }

    public function change_language() {
        $language = (!empty($this->input->post('lg'))) ? $this->input->post('lg') : 'en';

        $tag = (!empty($this->input->post('tag'))) ? $this->input->post('tag') : 'ltr';
        $where = array('id'=>$this->session->userdata('id'));
        $this->db->where($where);
        if($this->session->userdata('usertype') == 'user') {
            $this->db->update('users', array('language' => $language));
        } else {
            $this->db->update('providers', array('language' => $language));
        }

        $this->session->set_userdata(array('user_select_language' => $language));

        $this->session->set_userdata(array('tag' => $tag));

    }

    public function update_multi_language() {

        if ($this->input->post()) {
            

            $page_key = $this->input->post('page_key');
            $lang_key = $this->input->post('lang_key');
            

            if ($this->data['admin_id'] > 1) {
                $message = (!empty($this->data['language_content']['lg_no_permission'])) ? $this->data['language_content']['lg_no_permission'] : 'Permission Denied';
                $this->session->set_flashdata('message', '<p class="alert alert-danger">'.$message.'</p>');
                redirect(base_url() . 'app_page_list/' . $page_key . '/'.$lang_key.'');
            } else {


                $data = $this->input->post();




                foreach ($data as $row => $object) {
                    if (!empty($object)) {

                        foreach ($object as $key => $value) {

                            $this->db->where('language', $key);
                            $this->db->where('lang_key', $row);
                            $this->db->where('type', $value['type']);
                            $this->db->where('page_key', $page_key);

                            $record = $this->db->count_all_results('app_language_management');
                            


                            if ($record == 0) {
                                $array = array(
                                    'language' => $key,
                                    'lang_key' => $row,
                                    'lang_value' => $value['lang_value'],
                                    'placeholder' => $value['placeholder'],
                                    'validation1' => $value['validation1'],
                                    'validation2' => $value['validation2'],
                                    'validation3' => $value['validation3'],
                                    'type' => $value['type'],
                                    'page_key' => $page_key,
                                );

                                $this->db->insert('app_language_management', $array);
                            } else {

                                $this->db->where('language', $key);
                                $this->db->where('lang_key', $row);
                                $this->db->where('type', $value['type']);
                                $this->db->where('page_key', $page_key);
                                $this->db->where('language', $lang_key);


                                $array = array(
                                    'lang_value' => $value['lang_value'],
                                    'placeholder' => $value['placeholder'],
                                    'validation1' => $value['validation1'],
                                    'validation2' => $value['validation2'],
                                    'validation3' => $value['validation3'],
                                    'type' => $value['type'],
                                    'page_key' => $page_key,
                                );

                                $this->db->update('app_language_management', $array);

                                
                            }
                        }
                    }
                }
            }
        }
        redirect(base_url() . 'app_page_list/' . $page_key . '/'.$lang_key.'');
    }
    
    public function AppKeyword() {
        $this->common_model->checkAdminLogin();
        $postdata = $this->input->post();
        $page_key = $this->input->post('page_key');
        $lang_key = $this->input->post('lang_key');

        $key = str_replace(' ', '_', $postdata['filed_name']);
        $langKey = 'lbl_'.$key;
        $data=[
            'page_key' => $page_key,
            'lang_key' => $langKey,
            'lang_value' => $postdata['name'],
            'placeholder' => $postdata['placeholder'],
            'validation1' => $postdata['valide_1'],
            'validation2' => $postdata['valide_2'],
            'validation3' =>$postdata['valide_3'],
            'type' => 'App',
            'language' => 'en',
        ];
        
        $insertPage = $this->db->insert('app_language_management', $data);
        if (!empty($insertPage) && $insertPage != '') {
            $message = (!empty($this->data['language_content']['lg_admin_keyword_add'])) ? $this->data['language_content']['lg_admin_keyword_add'] : 'Keyword added successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "app_page_list/".$page_key.'/'.$lang_key);
        } else {
            $message = (!empty($this->data['language_content']['lg_admin_keyword_not_add'])) ? $this->data['language_content']['lg_admin_keyword_not_add'] : 'Keyword added not successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . 'app_page_list/' . $page_key . '/'.$lang_key);
        }
    }
    public function editAppkeyword($id){
        if (!empty($id)) {
            if ($this->input->post('form_submit')) {
            $id = $this->input->post('id');
            $table_data['page_title'] = $this->input->post('page_title');
            $table_data['status'] = 1;
            $this->db->where('p_id', $id);
            if ($this->db->update('pages', $table_data)) {
                $message = (!empty($this->data['language_content']['lg_admin_appkeyword_update'])) ? $this->data['language_content']['lg_admin_appkeyword_update'] : 'Appkeyword updated successfully. ';
            $this->session->set_flashdata('success_message', $message);
            redirect(base_url() . "app_page_list");
            } else {
                $message = (!empty($this->data['language_content']['lg_something_went_wrong'])) ? $this->data['language_content']['lg_something_went_wrong'] : 'Something went wrong, Try again';
                $this->session->set_flashdata('error_message', $message);
                redirect(base_url() . "app_page_list");
            }
            }
        
        }
        $this->data['page'] = 'edit_language';
        $this->data['pages'] = $this->language_model->edit_appkeyword($id);
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function delete_appkeyword() {
        $id = $this->input->post('appkeyword_id');       
        $table_data['status'] = 0;    
            $this->db->where('p_id', $id);
            if ($this->db->update('pages', $table_data)) {
                $message = (!empty($this->data['language_content']['lg_admin_appkeyword_delete'])) ? $this->data['language_content']['lg_admin_appkeyword_delete'] : 'App_Keyword deleted successfully. ';
                $this->session->set_flashdata('success_message', $message);
                echo 1;
            } else {
                $message = (!empty($this->data['language_content']['lg_something_went_wrong'])) ? $this->data['language_content']['lg_something_went_wrong'] : 'Something went wrong, Try again';
                    $this->session->set_flashdata('error_message', $message);
                     echo 2;
                }
                
    }

    //Language Listing
    public function languages_new() {
        $this->data['language'] = $this->db->get_where('language', array('status!='=>0))->result();
        $this->data['page'] = 'languages_new';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }
    public function languages_html() {
        $this->data['language'] = $this->db->get_where('language', array('status!='=>0))->result();
        $this->data['language_default'] = $this->db->get_where('language_default', array('status!='=>0))->result();
       
        $this->data['total_keyword_count'] = count($this->db->get_where('language_keywords_management', array('language'=> 'en'))->result());      
        $this->data['page'] = 'language_html';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function languages_html1() {
        $this->data['language'] = $this->db->get_where('language', array('status!='=>0))->result();
        $this->data['page'] = 'language-settings-web';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
        
        // $this->load->view('admin/language/language_html');
    }

    public function languages_html2() {
        $this->data['language'] = $this->db->get_where('language', array('status!='=>0))->result();
        $this->data['page'] = 'language_html2';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
        
        // $this->load->view('admin/language/language_html');
    }

    //Add New Language
    public function addLanguage() {
        if($this->input->post('form_submit') == true) {
            $this->common_model->checkAdminLogin();
            $lang_data['language'] = $this->input->post('language');
            $lang_data['language_value'] = $this->input->post('language_value');
            $lang_data['status'] = $this->input->post('status');
            $lang_data['tag'] = $this->input->post('tag');
            if ($this->db->insert('language', $lang_data)) {
                language_file_create();
                $message = (!empty($this->data['language_content']['lg_admin_language_add'])) ? $this->data['language_content']['lg_admin_language_add'] : 'Language added successfully. ';
                $this->session->set_flashdata('success_message', $message);
                redirect(base_url() . "languages");
            } else {
                $message = (!empty($this->data['language_content']['lg_something_went_wrong'])) ? $this->data['language_content']['lg_something_went_wrong'] : 'Something went wrong, Try again';
                $this->session->set_flashdata('error_message', $message);
                redirect(base_url() . "languages");
            }
        } 
        $this->data['page'] = 'add_language';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }
    //Update Existing Language Details
    public function editLanguages($lang_value) {
        if($this->input->post('form_submit') == true) {
            $this->common_model->checkAdminLogin();
            $lang_data['language'] = $this->input->post('language');
            $lang_data['language_value'] = $this->input->post('language_value');
            $lang_data['status'] = $this->input->post('status');
            $lang_data['tag'] = $this->input->post('tag');
            $id = $this->input->post('lang_id');
            $this->db->where('id', $id);
            if ($this->db->update('language', $lang_data)) {
                $message = (!empty($this->data['language_content']['lg_admin_language_update'])) ? $this->data['language_content']['lg_admin_language_update'] : 'Language updated successfully. ';
                $this->session->set_flashdata('success_message', 'Language updated successfully');
                redirect(base_url() . "languages");
            } else {
                $message = (!empty($this->data['language_content']['lg_something_went_wrong'])) ? $this->data['language_content']['lg_something_went_wrong'] : 'Something went wrong, Try again';
                $this->session->set_flashdata('error_message', $message);
                redirect(base_url() . "languages");
            }
        } 
        $this->data['lang_details'] = $this->db->get_where('language', array('language_value'=>$lang_value))->row();
        $this->data['page'] = 'edit_languages';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    //Language Listing
    public function webLanguages() {
        $lang_val = $this->uri->segment(2);
        $this->data['lang_keywords'] =  $this->db->where(array('language'=>$lang_val, 'lang_key!=' => '','type' => 'web'))->order_by('sno',"DESC")->get('language_management')->result();
        $this->data['langName'] = $this->db->select('')->get_where('language', array('language_value'=>$lang_val))->row()->language;
        $this->data['page'] = 'web_languages';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    public function update_language_keyword() {
        $data = $this->input->post();
        if($this->input->post()) {
            $this->db->where(array('sno'=>$data['id'], 'language'=>$data['lang_key']));
            $array = array(
                'lang_value' => $data['lang_value'],
            );
            $this->db->update('language_management', $array);
            language_file_create();
            if($this->db->affected_rows() > 0) {
                echo '1';
            } else {
                echo '2';
            }
        }
    }


    public function updateLangTag() {
        $data = $this->input->post();
        if($data) {
            $array_tag = array(
                'tag' => $data['tag'],
            );
            $this->db->where(array('id'=>$data['id']));
            if($this->db->update('language', $array_tag)) {
                echo '1';
            } else {
                echo '2';
            }
        }
    }

    //Update Language Status and update 
    public function updateLangStatus() {
        $data = $this->input->post();
        $lang_key = $this->db->get_where('language', array('id'=>$data['id']))->row()->language_value;
        if($data) {
            $array_tag = array(
                'status' => $data['status'],
            );
            $this->db->where(array('id'=>$data['id']));
            if($this->db->update('language', $array_tag)) {
                echo '1';
            } else {
                echo '2';
            }
        }
    }

    //Admin Language
    public function adminwebLanguages() {
        $lang_val = $this->uri->segment(2);
        $this->data['lang_keywords'] =  $this->db->where(array('language'=>$lang_val, 'lang_key!=' => '','type' => 'admin'))->order_by('sno',"DESC")->get('language_management')->result();
        $this->data['langName'] = $this->db->select('')->get_where('language', array('language_value'=>$lang_val))->row()->language;
        $this->data['page'] = 'admin_web_languages';
        $this->data['module']  = 'language';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }
    public function AddadminKeyword($lang_key) {
        if($this->input->post('form_submit') == true) {
            $this->common_model->checkAdminLogin();
          $postdata = $this->input->post();
          $web = 'admin';
          $data = [
              'lang_value' => $postdata['filed_name'],
              'lang_key' => str_replace(array(' ', '!', '&'), '_', 'lg_'.strtolower($postdata['key_name'])),
              'language' => $lang_key,
              'type' => $web
          ];
          $insert = $this->db->insert('language_management', $data);
          if (!empty($insert) && $insert != '') {
            $message = (!empty($this->data['language_content']['lg_admin_language_keyword_add'])) ? $this->data['language_content']['lg_admin_language_keyword_add'] : 'Language keyword added successfully. ';
            $this->session->set_flashdata('success_message',  $message);
            redirect(base_url() . "admin-web-languages/".$lang_key);
          } else {
            $message = (!empty($this->data['language_content']['lg_admin_language_key_not_add'])) ? $this->data['language_content']['lg_admin_language_key_not_add'] : 'Language keyword added not successfully. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "add-admin-keyword".$lang_key);
          }
        }
        $this->data['page'] = 'add_admin_keyword';
        $this->data['module']  = 'language';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    /** [Web Language Export] */
    public function exportlang($language) {
        $language_data = $this->db->query('SELECT lke.lang_value as def_lang_value,
        (SELECT lsub.lang_value FROM language_keywords_management lsub WHERE lsub.lang_key=lke.lang_key AND lsub.language="'.$language.'"  and lsub.delete_status=0 LIMIT 1) as lang_value, "'.$language.'" as language 
        FROM `language_keywords_management` lke WHERE lke.language="en" and lke.delete_status=0 and');
        $language_value = $this->db->select('language')->get_where('language', array('language_value'=>$language))->row()->language;        
        if($language_value){
            // $language = $this->input->post('dropdownLang');
            $file_name = ucfirst($language_value).'-Keywords-'.date('Y').'.csv'; 
            header("Content-Description: File Transfer"); 
            header("Content-Disposition: attachment; filename=$file_name"); 
            header("Content-Type: application/csv;");
           
            // get data 
            // $language_data = $this->language_model->lang_fetch_data($language);
            
            // file creation 
            $file = fopen('php://output', 'w');
         
            $header = array("English Keywords", $language_value." Keywords", "Code"); 
            fputcsv($file, $header);
            foreach ($language_data->result_array() as $key => $value)
            { 
              fputcsv($file, $value); 
            }
            fclose($file); 
            exit; 
        }
        else{
            $message = (!empty($this->data['language_content']['lg_admin_language_type'])) ? $this->data['language_content']['lg_admin_language_type'] : 'Invalid Language Type. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "languages-settings");
        }
    }
    public function exportlangType($language,$type) {
        if($type==1){
            $name='Web';
        }
        else if($type==2){
            $name='App';
        }
        else if($type==3){
            $name='Admin';
        }
        
        if($type==2){
            $language_data =  $this->db->query('SELECT lke.lang_value as def_lang_value,
            (SELECT lsub.lang_value FROM app_language_management lsub WHERE lsub.lang_key=lke.lang_key AND lsub.language="'.$language.'" LIMIT 1) as lang_value 
            FROM `app_language_management` lke WHERE lke.language="en" AND lke.lang_value!="";');
        }else{
            $language_data = $this->db->query('SELECT lke.lang_value as def_lang_value,
            (SELECT lsub.lang_value FROM language_keywords_management lsub WHERE lsub.lang_key=lke.lang_key AND lsub.language="'.$language.'"  and lsub.delete_status=0 AND lsub.type="'.$type.'" LIMIT 1) as lang_value, "'.$language.'" as language 
            FROM `language_keywords_management` lke WHERE lke.language="en" and lke.delete_status=0 and lke.type="'.$type.'"');            
        }
        
        $language_value = $this->db->select('language')->get_where('language', array('language_value'=>$language))->row()->language;        
        if($language_value){
            // $language = $this->input->post('dropdownLang');
            $file_name = $name.'-'.ucfirst($language_value).'-Keywords-'.date('Y').'.csv'; 
            header("Content-Description: File Transfer"); 
            header("Content-Disposition: attachment; filename=$file_name"); 
            header("Content-Type: application/csv;");
           
            // get data 
            // $language_data = $this->language_model->lang_fetch_data($language);
            
            // file creation 
            $file = fopen('php://output', 'w');
         
            $header = array("English Keywords", $language_value." Keywords", "Code"); 
            fputcsv($file, $header);
            foreach ($language_data->result_array() as $key => $value)
            { 
              fputcsv($file, $value); 
            }
            fclose($file); 
            exit; 
        }
        else{
            $message = (!empty($this->data['language_content']['lg_admin_language_type'])) ? $this->data['language_content']['lg_admin_language_type'] : 'Invalid Language Type. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "languages-settings");
        }
    }
    /** [Web Language Import] */
    public function importlang() {
        if ($_FILES) {
            $skip_rows = $this->input->post('skip_rows');
            $is_success = 0;
            
            if (!empty($_FILES['add_language'])) {
                $config['upload_path'] = 'uploads/attachments/csv/';

                $config['allowed_types'] = 'csv';
                
                //Create a new file directory
                if(!is_dir($config['upload_path'])) {
                    mkdir('./uploads/attachments/csv/', 0777, TRUE);
                }
                
                $this->load->library('upload', $config);

                $random_hash = substr(str_shuffle(time()), 0, 3) . strrev(mt_rand(100000, 999999));
                
                $extension = pathinfo($_FILES['add_language']['name'], PATHINFO_EXTENSION);

                $new_file_name = 'language_' . $random_hash . '.' . $extension;

                $_FILES['add_language'] = array(
                    'name' => $new_file_name,
                    'type' => $_FILES['add_language']['type'],
                    'tmp_name' => $_FILES['add_language']['tmp_name'],
                    'error' => $_FILES['add_language']['error'],
                    'size' => $_FILES['add_language']['size']
                );

                $this->upload->initialize($config);
                


                $this->upload->do_upload('add_language');

                $upload_data = $this->upload->data();

                $file_name = $upload_data['file_name'];

                $file = 'uploads/attachments/csv/' . $file_name;
                // $file = base_url() . 'attachements/csv/sample_product.xlsx';
                $handle = fopen($file, 'r');

                $lineNum = 1;
                if ($file != NULL && $skip_rows > 0 || $lineNum == 1) {

                    $skipLines = $skip_rows;


                    if ($skipLines > 0 || $lineNum == 1) {

                        while (fgetcsv($handle)) {

                            if ($lineNum == $skipLines || $lineNum == 1) {

                                break;
                            }

                            $lineNum++;
                        }
                    }
                }
            
                $count = 1;
                
                if ($file != NULL) {
                    $language  = $this->input->post('lang_code');
                    $lang_type  = $this->input->post('lang_type')?$this->input->post('lang_type'):'';
                    $updateWithType=false;
                    if($lang_type!="" && $lang_type>0){
                        $updateWithType=true;
                    }
                    while ($row_data = fgetcsv($handle)) {
                        $en_lang_value  = $row_data[0];
                        if($updateWithType==true){
                            $en_language = $this->db->get_where('language_keywords_management', array('lang_value='=>$en_lang_value,'type='=>$lang_type,'language'=>'en'))->row_array();
                        }else{
                            $en_language = $this->db->get_where('language_keywords_management', array('lang_value='=>$en_lang_value,'language'=>'en'))->row_array();
                        }
                        
                        $lang_key=$en_language['lang_key'];
                        if($row_data[1]!="" && $row_data[1]!="" && $en_language && $language==$row_data[2])
                        {                        
                            $update_lang = array(
                                    'lang_key' => $lang_key,
                                    'lang_value' => $row_data[1],
                                    'language' => $row_data[2],
                                    'type' => $en_language['type'],
                                    'module_id' => $en_language['module_id'],
                            );
                            $lang_check = $this->language_model->check_language_new($lang_key,$row_data[2],$lang_type);
                            if ($lang_check != 0){
                                $this->db->where('id', $lang_check)->update('language_keywords_management', $update_lang);
                            } else {
                                $this->db->insert('language_keywords_management' ,$update_lang);
                            }
                        }
                        $update_lang = array();
                    }

                    language_file_content_change($language);
                    $message = (!empty($this->data['language_content']['lg_admin_language_update'])) ? $this->data['language_content']['lg_admin_language_update'] : 'Language updated successfully. ';
                    $this->session->set_flashdata('success_message', $message);
                    redirect(base_url() . "languages-settings");
                }
            }
        }
    }
    /** [App Language Export] */
    public function exporapptlang() {
        $file_name = 'applanguage'.date('Ymd').'.csv'; 
        header("Content-Description: File Transfer"); 
        header("Content-Disposition: attachment; filename=$file_name"); 
        header("Content-Type: application/csv;");
       
        // get data 
        $languageapp_data = $this->language_model->fetch_app_data();

        // file creation 
        $file = fopen('php://output', 'w');
     
        $header = array("page_key", "language_key", "value", "placeholder", "validation1", "validation2", "validation3", "language"); 
        fputcsv($file, $header);
        foreach ($languageapp_data->result_array() as $key => $value)
        { 
          fputcsv($file, $value); 
        }
        fclose($file); 
        exit; 
    }
    /** [App Language Import] */
    public function importapplang() {
        if ($_FILES) {
            
            $skip_rows = $this->input->post('skip_rows');
            $is_success = 0;
            
            if (!empty($_FILES['add_app_language'])) {
                $config['upload_path'] = 'uploads/attachments/csv/';

                $config['allowed_types'] = 'csv';
 
                $this->load->library('upload', $config);

                $random_hash = substr(str_shuffle(time()), 0, 3) . strrev(mt_rand(100000, 999999));
                
                $extension = pathinfo($_FILES['add_app_language']['name'], PATHINFO_EXTENSION);

                $new_file_name = 'language_' . $random_hash . '.' . $extension;

                $_FILES['add_app_language'] = array(
                    'name' => $new_file_name,
                    'type' => $_FILES['add_app_language']['type'],
                    'tmp_name' => $_FILES['add_app_language']['tmp_name'],
                    'error' => $_FILES['add_app_language']['error'],
                    'size' => $_FILES['add_app_language']['size']
                );

                $this->upload->initialize($config);
                


                $this->upload->do_upload('add_app_language');

                $upload_data = $this->upload->data();

                $file_name = $upload_data['file_name'];

                $file = 'uploads/attachments/csv/' . $file_name;
                $handle = fopen($file, 'r');

                $lineNum = 1;
                if ($file != NULL && $skip_rows > 0 || $lineNum == 1) {

                    $skipLines = $skip_rows;


                    if ($skipLines > 0 || $lineNum == 1) {

                        while (fgetcsv($handle)) {

                            if ($lineNum == $skipLines || $lineNum == 1) {

                                break;
                            }

                            $lineNum++;
                        }
                    }
                }
                // echo "hjkhj";die;
                $count = 1;
                if ($file != NULL) {
                    $language = $this->input->post('lang_code');

                    while ($row_data = fgetcsv($handle)) {
                        if($row_data[1]!="" && $language==$row_data[2]){
                            $en_lang_value  = $row_data[0];
                            $get_en_lang = $this->language_model->get_en_language_keys($en_lang_value);
                            // print_r($get_en_lang);
                            $page_key  = $get_en_lang?$get_en_lang['page_key']:'';
                            $lang_key  = $get_en_lang?$get_en_lang['lang_key']:'';
                            $app_lang_check = $this->language_model->check_app_language($page_key,$lang_key,$language);
                            // print_r($app_lang_check);

                            $update_lang = array(
                                'page_key' => $page_key,
                                'lang_key' => $lang_key,
                                'lang_value' => $row_data[1],
                                'language' => $language,
                                'type' => 'App',
                                );

                            if ($app_lang_check != 0) {
                                $this->db->where('sno', $app_lang_check)->update('app_language_management', $update_lang);
                                
                            } else {
                                $this->db->insert('app_language_management' ,$update_lang);
                            }
                            $update_lang = array();
                        }
                    }
                    $message = (!empty($this->data['language_content']['lg_amdin_app_language_update'])) ? $this->data['language_content']['lg_amdin_app_language_update'] : 'App Language updated successfully. ';
                    $this->session->set_flashdata('success_message', $message);
                    redirect(base_url() . "languages-settings");
                }
            }
        }
    }

    //Language Listing
    public function webLanguageKeyword($id)
    {
        $lang_val=$_GET['language']??"en";
        $type=$_GET['type']??"web";
        if($type=='web'){
            $type=1;
        }else{
            $type=3;
        }
        // $this->data['lang_keywords'] =  $this->db->where(array('language'=>$lang_val,'module_id'=>$id, 'lang_key!=' => '','status'=>1,'type!=' => 2))->order_by('id',"DESC")->get('language_keywords_management')->result();
        $this->data['lang_keywords'] =  $this->db->query('SELECT lke.id,lke.lang_key,lke.lang_value as def_lang_value,
        (SELECT lsub.lang_value FROM language_keywords_management lsub WHERE lsub.lang_key=lke.lang_key AND lsub.language="'.$lang_val.'" LIMIT 1) as lang_value 
        FROM `language_keywords_management` lke WHERE lke.language="en" AND lke.module_id=? AND lke.type=?  and lke.delete_status=0',array($id,$type))->result();
        $this->data['module_id']=$id;
        $this->data['langName'] = $this->db->select('')->get_where('language', array('language_value'=>$lang_val))->row()->language;
        $this->data['module'] = $this->db->select('')->get_where('language_module', array('id'=>$id))->row()->module_name;
        $this->data['page'] = 'web_lang_module_keywords';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }

    //for new design
    public function webLanguageKeywordNew($id)
    {
        $lang_val=$_GET['language']??"en";
        $type=$_GET['type']??"web";
        $type_val=$_GET['type']??"web";
        if($type=='web'){
            $type=1;
        }else{
            $type=3;
        }
        
        // $this->data['lang_keywords'] =  $this->db->where(array('language'=>$lang_val,'module_id'=>$id, 'lang_key!=' => '','status'=>1,'type!=' => 2))->order_by('id',"DESC")->get('language_keywords_management')->result();
        $this->data['lang_keywords'] =  $this->db->query('SELECT lke.id,lke.lang_key,lke.lang_value as def_lang_value,
        (SELECT lsub.lang_value FROM language_keywords_management lsub WHERE lsub.lang_key=lke.lang_key AND module_id='.$id.' AND lsub.language="'.$lang_val.'" AND lsub.type='.$type.' LIMIT 1) as lang_value 
        FROM `language_keywords_management` lke WHERE lke.language="en" AND lke.module_id=? AND lke.type=? and lke.delete_status=0',array($id,$type))->result();
      
        // echo $this->db->last_query();die;
        $this->data['module_id']=$id;
        $this->data['langName'] = $this->db->select('')->get_where('language', array('language_value'=>$lang_val))->row()->language;
        $this->data['lang_val'] = $lang_val;

        $this->data['module'] = $this->db->select('')->get_where('language_module', array('id'=>$id))->row()->module_name;
        $this->data['page'] = 'language_html2';        
        if($type_val!="web" && $type_val!="admin")
        {
            $message = (!empty($this->data['language_content']['lg_admin_application_not_found'])) ? $this->data['language_content']['lg_admin_application_not_found'] : 'Application Not Found. ';
            $this->session->set_flashdata('error_message',  $message);
            redirect(base_url() . "languages-settings");
        }
        else if($this->data['langName']){
            $this->load->vars($this->data);
            $this->load->view($this->data['theme'] . '/template');
        }else{
            $message = (!empty($this->data['language_content']['lg_admin_language_not_found'])) ? $this->data['language_content']['lg_admin_language_not_found'] : 'Language Not Found. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "languages-settings");
        }
    }

    /**
     * This list access when you click web in language module
     */
    public function LangModuleList() 
    {
        $lang_val=$_GET['language']??"en";
        $this->data['langName'] = $this->db->select('')->get_where('language', array('language_value'=>$lang_val))->row()->language;   
        $this->data['list'] = $this->language_model->languageModule_list();       
        $this->data['page'] = 'web_lang_module_list';
        $this->load->vars($this->data);
        $this->load->view($this->data['theme'] . '/template');
    }


    public function LangModuleListNew() 
    {
        $lang_val=$_GET['language']??"en";
        $type_val= $_GET['type']??"web";
        $this->data['langName'] = $this->db->select('')->get_where('language', array('language_value'=>$lang_val))->row()->language;   
           
        $this->data['list'] = $this->language_model->languageModule_list();   
        $this->data['page'] = 'language-settings-web';
        if($type_val!="web" && $type_val!="admin")
        {
            $message = (!empty($this->data['language_content']['lg_admin_application_not_found'])) ? $this->data['language_content']['lg_admin_application_not_found'] : 'Application Not Found. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "languages-settings");
        }
        else if($this->data['langName'])
        {
            $this->load->vars($this->data);
            $this->load->view($this->data['theme'] . '/template');
        }else{
            $message = (!empty($this->data['language_content']['lg_admin_language_not_found'])) ? $this->data['language_content']['lg_admin_language_not_found'] : 'Language Not Found. ';
            $this->session->set_flashdata('error_message', $message);
            redirect(base_url() . "languages-settings");
        }
    }

    public function update_module_language_keyword() {
        $data = $this->input->post();
        if($this->input->post())
        {
            $type = $data['type'];
            if($type=='web')  {
                $typeval=1;
            }else if($type=='admin')  {
                $typeval=3;
                }else{
                    $typeval=2;
                }
            $where=array('language'=>$data['lang'],'lang_key'=>$data['lang_key']);
            if($this->db->select('')->get_where('language_keywords_management', $where)->row()){
                $this->db->where($where);
                $array = array(
                    'module_id' => $data['module_id'],
                    'lang_value' => $data['lang_value'],
                    'type'=>$typeval
                );    
                if($this->db->update('language_keywords_management', $array)) {
                    echo '1';
                } else {
                    echo '2';
                }
            }else{
                $array = array(
                    'module_id' => $data['module_id'],
                    'lang_value' => $data['lang_value'],
                    'language'=>$data['lang'],
                    'lang_key'=>$data['lang_key'],
                    'type'=>$typeval
                );    
                if($this->db->insert('language_keywords_management', $array)) {
                    echo '1';
                } else {
                    echo '2';
                }
            }
                    
            language_module_file_create($data['lang'],$data['lang_key'],$data['lang_value']);            
        }
    }

    public function language_export() {
        $file_name = 'Language-List-'.date('Y').'.csv'; 
        header("Content-Description: File Transfer"); 
        header("Content-Disposition: attachment; filename=$file_name"); 
        header("Content-Type: application/csv;");
       
        // get data 
        $language_data = $this->db->select('language,language_value,')->where(array('status!='=>0))->get('language')->result_array();
        $total_keyword_count = count($this->db->get_where('language_keywords_management', array('language'=> 'en'))->result());  

        // Create an array to hold all rows of data
        $csv_data = array();

        // Add the header row
        $csv_data[] = array("Language", "Code", "Total","Done","Progress");

        // Add data rows
        foreach ($language_data as $lang) {
            $count_done_keywords = count($this->db->get_where('language_keywords_management', array('language'=> $lang['language_value']))->result());
            $donePercent = ($count_done_keywords/$total_keyword_count)*100;
            $csv_data[] = array($lang['language'], $lang['language_value'], $total_keyword_count,$count_done_keywords,round($donePercent));
        }

        // Create the CSV file in memory
        $csv_file = fopen('php://output', 'w');

        // Write the data to the CSV file
        foreach ($csv_data as $row) {
            fputcsv($csv_file, $row);
        }

        // Close the CSV file
        fclose($csv_file);
        exit;
    }

    public function language_pdf() {
        $data['language'] = $this->db->get_where('language', array('status!='=>0))->result_array();
        $data['total_keyword_count'] = count($this->db->get_where('language_keywords_management', array('language'=> 'en'))->result()); 
        $this->load->view('admin/language/language_pdf', $data);
    }

    public function language_print() {
        $data['language'] = $this->db->get_where('language', array('status!='=>0))->result_array();
        $data['total_keyword_count'] = count($this->db->get_where('language_keywords_management', array('language'=> 'en'))->result()); 
        $this->load->view('admin/language/language_print', $data);
    }
    
    public function sample_csv()
    {
      // $this->input->post('attendance_month') = date('m');
      // $this->input->post('attendance_year')=date('Y');
    //   $data['attendance_date']= $this->input->post('attendance_date');
    //   $data['attendance_list'] = $this->Attendance_user_model->attendance_datatable_list(); 
      // $attendance_list = $this->Attendance_user_model->attendance_datatable_list(); 
      // echo '<pre>' ; print_r( $data['attendance_list']);
      // exit();
      $this->load->view('admin/include/sample_excel');
    }    
}

